const express = require('express');

const app = express();
const port = 3005;

app.use(require('cors')());
app.use(express.json());
app.use(express.urlencoded({
    extended: true
}));

const data = database();

app.get('/products', (req, res) => {

    res.json(database());

})

app.post('/products', (req, res) => {

    const { first, last, filtering, sorting } = req.body;

    const responseData = reduceData(first, last, filtering, sorting);

    res.json(responseData);
})

let id = data.length;
app.post('/products/add', (req, res) => {

    const { first, last, filtering, sorting } = req.body;

    data.push({
        id: ++id,
        firstName: '',
        lastName: '',
        productName: '',
        quantity: '',
        price: '',
        total: ''
    })

    const responseData = reduceData(first, last, filtering, sorting);

    res.json(responseData);

})

app.put('/products/edit', (req, res) => {

    const { first, last, filtering, sorting, query } = req.body;

    const updateQuery = query.update.trim()
        .split(', ');

    const firstName = updateQuery[0].match(/(?<=firstName=')(.*)(?=')/)[1];
    const lastName = updateQuery[1].match(/(?<=lastName=')(.*)(?=')/)[1];
    const productName = updateQuery[2].match(/(?<=productName=')(.*)(?=')/)[1];
    const quantity = Number(updateQuery[3].match(/(?<=quantity=')(.*)(?=')/)[1]);
    const price = Number(updateQuery[4].match(/(?<=price=')(.*)(?=')/)[1]);
    const total = Number(updateQuery[5].match(/(?<=total=')(.*)(?=')/)[1]);
    const id = updateQuery[5].match(/id=(\d+)/)[1];

    const index = data.findIndex(p => p.id === Number(id))

    data[index] = { id: Number(id), firstName, lastName, productName, quantity, price, total }

    const responseData = reduceData(first, last, filtering, sorting);

    res.json(responseData);
})

app.delete('/products/delete', (req, res) => {

    const { first, last, filtering, sorting, query } = req.body;

    const updateQuery = query.remove
        .trim();
        
    const match = updateQuery.match(/id=(\d+)/)

    if (match) {
        const id = match[1];

        const index = data.findIndex(p => p.id === Number(id))

        data.splice(index, 1);
    }

    const responseData = reduceData(first, last, filtering, sorting);

    res.json(responseData);
})

app.listen(port, () => {
    console.log(`Listening on ${port}`);
});

function database() {
    return [
        {
            "id": 1,
            "firstName": "Nancy",
            "lastName": "Nodier",
            "productName": "Doubleshot Espresso",
            "price": 3.3,
            "quantity": 2,
            "total": 6.6
        },
        {
            "id": 2,
            "firstName": "Andrew",
            "lastName": "Winkler",
            "productName": "Espresso Truffle",
            "price": 1.75,
            "quantity": 11,
            "total": 19.25
        },
        {
            "id": 3,
            "firstName": "Sven",
            "lastName": "Bjorn",
            "productName": "Caffe Espresso",
            "price": 3,
            "quantity": 5,
            "total": 15
        },
        {
            "id": 4,
            "firstName": "Petra",
            "lastName": "Nagase",
            "productName": "Espresso con Panna",
            "price": 3.25,
            "quantity": 5,
            "total": 16.25
        },
        {
            "id": 5,
            "firstName": "Regina",
            "lastName": "Nagase",
            "productName": "Cramel Latte",
            "price": 3.8,
            "quantity": 9,
            "total": 34.199999999999996
        },
        {
            "id": 6,
            "firstName": "Nancy",
            "lastName": "Vileid",
            "productName": "Black Tea",
            "price": 2.25,
            "quantity": 11,
            "total": 24.75
        },
        {
            "id": 7,
            "firstName": "Petra",
            "lastName": "Burke",
            "productName": "Cramel Latte",
            "price": 3.8,
            "quantity": 9,
            "total": 34.199999999999996
        },
        {
            "id": 8,
            "firstName": "Martin",
            "lastName": "Saavedra",
            "productName": "Caffe Latte",
            "price": 4.5,
            "quantity": 10,
            "total": 45
        },
        {
            "id": 9,
            "firstName": "Elio",
            "lastName": "Saavedra",
            "productName": "Caffe Espresso",
            "price": 3,
            "quantity": 9,
            "total": 27
        },
        {
            "id": 10,
            "firstName": "Guylene",
            "lastName": "Burke",
            "productName": "Caffe Latte",
            "price": 4.5,
            "quantity": 7,
            "total": 31.5
        },
        {
            "id": 11,
            "firstName": "Michael",
            "lastName": "Saylor",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 10,
            "total": 36
        },
        {
            "id": 12,
            "firstName": "Shelley",
            "lastName": "Saylor",
            "productName": "Green Tea",
            "price": 1.5,
            "quantity": 7,
            "total": 10.5
        },
        {
            "id": 13,
            "firstName": "Sven",
            "lastName": "Bein",
            "productName": "Doubleshot Espresso",
            "price": 3.3,
            "quantity": 5,
            "total": 16.5
        },
        {
            "id": 14,
            "firstName": "Martin",
            "lastName": "Ohno",
            "productName": "Cramel Latte",
            "price": 3.8,
            "quantity": 6,
            "total": 22.799999999999997
        },
        {
            "id": 15,
            "firstName": "Nancy",
            "lastName": "Wilson",
            "productName": "Caffe Espresso",
            "price": 3,
            "quantity": 10,
            "total": 30
        },
        {
            "id": 16,
            "firstName": "Petra",
            "lastName": "Nagase",
            "productName": "Espresso con Panna",
            "price": 3.25,
            "quantity": 7,
            "total": 22.75
        },
        {
            "id": 17,
            "firstName": "Regina",
            "lastName": "Devling",
            "productName": "Doubleshot Espresso",
            "price": 3.3,
            "quantity": 5,
            "total": 16.5
        },
        {
            "id": 18,
            "firstName": "Peter",
            "lastName": "Devling",
            "productName": "Peppermint Mocha Twist",
            "price": 4,
            "quantity": 1,
            "total": 4
        },
        {
            "id": 19,
            "firstName": "Shelley",
            "lastName": "Rossi",
            "productName": "Cappuccino",
            "price": 5,
            "quantity": 8,
            "total": 40
        },
        {
            "id": 20,
            "firstName": "Mayumi",
            "lastName": "Nagase",
            "productName": "Espresso con Panna",
            "price": 3.25,
            "quantity": 10,
            "total": 32.5
        },
        {
            "id": 21,
            "firstName": "Michael",
            "lastName": "Davolio",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 8,
            "total": 28.8
        },
        {
            "id": 22,
            "firstName": "Sven",
            "lastName": "Burke",
            "productName": "Doubleshot Espresso",
            "price": 3.3,
            "quantity": 6,
            "total": 19.799999999999997
        },
        {
            "id": 23,
            "firstName": "Sven",
            "lastName": "Murphy",
            "productName": "Black Tea",
            "price": 2.25,
            "quantity": 7,
            "total": 15.75
        },
        {
            "id": 24,
            "firstName": "Antoni",
            "lastName": "Bjorn",
            "productName": "Caffe Americano",
            "price": 2.5,
            "quantity": 2,
            "total": 5
        },
        {
            "id": 25,
            "firstName": "Martin",
            "lastName": "Bjorn",
            "productName": "Cappuccino",
            "price": 5,
            "quantity": 9,
            "total": 45
        },
        {
            "id": 26,
            "firstName": "Petra",
            "lastName": "Saavedra",
            "productName": "Caffe Latte",
            "price": 4.5,
            "quantity": 7,
            "total": 31.5
        },
        {
            "id": 27,
            "firstName": "Petra",
            "lastName": "Nagase",
            "productName": "Doubleshot Espresso",
            "price": 3.3,
            "quantity": 6,
            "total": 19.799999999999997
        },
        {
            "id": 28,
            "firstName": "Andrew",
            "lastName": "Saavedra",
            "productName": "Caffe Latte",
            "price": 4.5,
            "quantity": 5,
            "total": 22.5
        },
        {
            "id": 29,
            "firstName": "Antoni",
            "lastName": "Bein",
            "productName": "Green Tea",
            "price": 1.5,
            "quantity": 8,
            "total": 12
        },
        {
            "id": 30,
            "firstName": "Antoni",
            "lastName": "Wilson",
            "productName": "Caffe Americano",
            "price": 2.5,
            "quantity": 11,
            "total": 27.5
        },
        {
            "id": 31,
            "firstName": "Cheryl",
            "lastName": "Fuller",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 4,
            "total": 14.4
        },
        {
            "id": 32,
            "firstName": "Michael",
            "lastName": "Devling",
            "productName": "Caffe Espresso",
            "price": 3,
            "quantity": 10,
            "total": 30
        },
        {
            "id": 33,
            "firstName": "Sven",
            "lastName": "Bjorn",
            "productName": "Caffe Espresso",
            "price": 3,
            "quantity": 11,
            "total": 33
        },
        {
            "id": 34,
            "firstName": "Lars",
            "lastName": "Ohno",
            "productName": "Caffe Espresso",
            "price": 3,
            "quantity": 3,
            "total": 9
        },
        {
            "id": 35,
            "firstName": "Antoni",
            "lastName": "Rossi",
            "productName": "Caffe Americano",
            "price": 2.5,
            "quantity": 2,
            "total": 5
        },
        {
            "id": 36,
            "firstName": "Yoshi",
            "lastName": "Nodier",
            "productName": "Black Tea",
            "price": 2.25,
            "quantity": 3,
            "total": 6.75
        },
        {
            "id": 37,
            "firstName": "Yoshi",
            "lastName": "Saavedra",
            "productName": "Cappuccino",
            "price": 5,
            "quantity": 2,
            "total": 10
        },
        {
            "id": 38,
            "firstName": "Mayumi",
            "lastName": "Murphy",
            "productName": "Caffe Latte",
            "price": 4.5,
            "quantity": 10,
            "total": 45
        },
        {
            "id": 39,
            "firstName": "Peter",
            "lastName": "Wilson",
            "productName": "Caffe Espresso",
            "price": 3,
            "quantity": 8,
            "total": 24
        },
        {
            "id": 40,
            "firstName": "Mayumi",
            "lastName": "Fuller",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 9,
            "total": 32.4
        },
        {
            "id": 41,
            "firstName": "Beate",
            "lastName": "Fuller",
            "productName": "Cramel Latte",
            "price": 3.8,
            "quantity": 8,
            "total": 30.4
        },
        {
            "id": 42,
            "firstName": "Cheryl",
            "lastName": "Bein",
            "productName": "Espresso con Panna",
            "price": 3.25,
            "quantity": 8,
            "total": 26
        },
        {
            "id": 43,
            "firstName": "Lars",
            "lastName": "Ohno",
            "productName": "Caffe Espresso",
            "price": 3,
            "quantity": 4,
            "total": 12
        },
        {
            "id": 44,
            "firstName": "Shelley",
            "lastName": "Davolio",
            "productName": "Black Tea",
            "price": 2.25,
            "quantity": 7,
            "total": 15.75
        },
        {
            "id": 45,
            "firstName": "Nancy",
            "lastName": "Murphy",
            "productName": "Caffe Espresso",
            "price": 3,
            "quantity": 9,
            "total": 27
        },
        {
            "id": 46,
            "firstName": "Peter",
            "lastName": "Ohno",
            "productName": "Green Tea",
            "price": 1.5,
            "quantity": 3,
            "total": 4.5
        },
        {
            "id": 47,
            "firstName": "Sven",
            "lastName": "Nodier",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 3,
            "total": 10.8
        },
        {
            "id": 48,
            "firstName": "Sven",
            "lastName": "Murphy",
            "productName": "Doubleshot Espresso",
            "price": 3.3,
            "quantity": 8,
            "total": 26.4
        },
        {
            "id": 49,
            "firstName": "Shelley",
            "lastName": "Vileid",
            "productName": "Cappuccino",
            "price": 5,
            "quantity": 9,
            "total": 45
        },
        {
            "id": 50,
            "firstName": "Lars",
            "lastName": "Winkler",
            "productName": "Black Tea",
            "price": 2.25,
            "quantity": 5,
            "total": 11.25
        },
        {
            "id": 51,
            "firstName": "Ian",
            "lastName": "Saylor",
            "productName": "Espresso con Panna",
            "price": 3.25,
            "quantity": 10,
            "total": 32.5
        },
        {
            "id": 52,
            "firstName": "Petra",
            "lastName": "Burke",
            "productName": "Green Tea",
            "price": 1.5,
            "quantity": 8,
            "total": 12
        },
        {
            "id": 53,
            "firstName": "Petra",
            "lastName": "Petersen",
            "productName": "Green Tea",
            "price": 1.5,
            "quantity": 11,
            "total": 16.5
        },
        {
            "id": 54,
            "firstName": "Antoni",
            "lastName": "Davolio",
            "productName": "Doubleshot Espresso",
            "price": 3.3,
            "quantity": 2,
            "total": 6.6
        },
        {
            "id": 55,
            "firstName": "Yoshi",
            "lastName": "Rossi",
            "productName": "Caffe Latte",
            "price": 4.5,
            "quantity": 11,
            "total": 49.5
        },
        {
            "id": 56,
            "firstName": "Cheryl",
            "lastName": "Nagase",
            "productName": "Caffe Americano",
            "price": 2.5,
            "quantity": 10,
            "total": 25
        },
        {
            "id": 57,
            "firstName": "Yoshi",
            "lastName": "Winkler",
            "productName": "Cappuccino",
            "price": 5,
            "quantity": 8,
            "total": 40
        },
        {
            "id": 58,
            "firstName": "Antoni",
            "lastName": "Ohno",
            "productName": "Cramel Latte",
            "price": 3.8,
            "quantity": 11,
            "total": 41.8
        },
        {
            "id": 59,
            "firstName": "Petra",
            "lastName": "Burke",
            "productName": "Cramel Latte",
            "price": 3.8,
            "quantity": 6,
            "total": 22.799999999999997
        },
        {
            "id": 60,
            "firstName": "Yoshi",
            "lastName": "Murphy",
            "productName": "Peppermint Mocha Twist",
            "price": 4,
            "quantity": 9,
            "total": 36
        },
        {
            "id": 61,
            "firstName": "Mayumi",
            "lastName": "Devling",
            "productName": "Caffe Espresso",
            "price": 3,
            "quantity": 2,
            "total": 6
        },
        {
            "id": 62,
            "firstName": "Petra",
            "lastName": "Murphy",
            "productName": "Caffe Americano",
            "price": 2.5,
            "quantity": 4,
            "total": 10
        },
        {
            "id": 63,
            "firstName": "Michael",
            "lastName": "Fuller",
            "productName": "Caffe Americano",
            "price": 2.5,
            "quantity": 2,
            "total": 5
        },
        {
            "id": 64,
            "firstName": "Ian",
            "lastName": "Peterson",
            "productName": "Caffe Americano",
            "price": 2.5,
            "quantity": 5,
            "total": 12.5
        },
        {
            "id": 65,
            "firstName": "Mayumi",
            "lastName": "Nagase",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 10,
            "total": 36
        },
        {
            "id": 66,
            "firstName": "Guylene",
            "lastName": "Bjorn",
            "productName": "Peppermint Mocha Twist",
            "price": 4,
            "quantity": 10,
            "total": 40
        },
        {
            "id": 67,
            "firstName": "Elio",
            "lastName": "Vileid",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 6,
            "total": 21.6
        },
        {
            "id": 68,
            "firstName": "Yoshi",
            "lastName": "Vileid",
            "productName": "Cramel Latte",
            "price": 3.8,
            "quantity": 7,
            "total": 26.599999999999998
        },
        {
            "id": 69,
            "firstName": "Peter",
            "lastName": "Peterson",
            "productName": "Cramel Latte",
            "price": 3.8,
            "quantity": 1,
            "total": 3.8
        },
        {
            "id": 70,
            "firstName": "Lars",
            "lastName": "Saavedra",
            "productName": "Espresso con Panna",
            "price": 3.25,
            "quantity": 4,
            "total": 13
        },
        {
            "id": 71,
            "firstName": "Andrew",
            "lastName": "Vileid",
            "productName": "Caffe Americano",
            "price": 2.5,
            "quantity": 4,
            "total": 10
        },
        {
            "id": 72,
            "firstName": "Mayumi",
            "lastName": "Ohno",
            "productName": "Espresso Truffle",
            "price": 1.75,
            "quantity": 9,
            "total": 15.75
        },
        {
            "id": 73,
            "firstName": "Sven",
            "lastName": "Bjorn",
            "productName": "Caffe Latte",
            "price": 4.5,
            "quantity": 2,
            "total": 9
        },
        {
            "id": 74,
            "firstName": "Yoshi",
            "lastName": "Wilson",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 6,
            "total": 21.6
        },
        {
            "id": 75,
            "firstName": "Regina",
            "lastName": "Burke",
            "productName": "Doubleshot Espresso",
            "price": 3.3,
            "quantity": 10,
            "total": 33
        },
        {
            "id": 76,
            "firstName": "Lars",
            "lastName": "Saavedra",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 4,
            "total": 14.4
        },
        {
            "id": 77,
            "firstName": "Elio",
            "lastName": "Saylor",
            "productName": "Black Tea",
            "price": 2.25,
            "quantity": 1,
            "total": 2.25
        },
        {
            "id": 78,
            "firstName": "Ian",
            "lastName": "Bjorn",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 6,
            "total": 21.6
        },
        {
            "id": 79,
            "firstName": "Beate",
            "lastName": "Saylor",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 4,
            "total": 14.4
        },
        {
            "id": 80,
            "firstName": "Shelley",
            "lastName": "Murphy",
            "productName": "Caffe Espresso",
            "price": 3,
            "quantity": 4,
            "total": 12
        },
        {
            "id": 81,
            "firstName": "Elio",
            "lastName": "Vileid",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 3,
            "total": 10.8
        },
        {
            "id": 82,
            "firstName": "Sven",
            "lastName": "Rossi",
            "productName": "Cramel Latte",
            "price": 3.8,
            "quantity": 9,
            "total": 34.199999999999996
        },
        {
            "id": 83,
            "firstName": "Beate",
            "lastName": "Wilson",
            "productName": "Espresso Truffle",
            "price": 1.75,
            "quantity": 6,
            "total": 10.5
        },
        {
            "id": 84,
            "firstName": "Andrew",
            "lastName": "Petersen",
            "productName": "White Chocolate Mocha",
            "price": 3.6,
            "quantity": 10,
            "total": 36
        },
        {
            "id": 85,
            "firstName": "Mayumi",
            "lastName": "Vileid",
            "productName": "Cramel Latte",
            "price": 3.8,
            "quantity": 8,
            "total": 30.4
        },
        {
            "id": 86,
            "firstName": "Shelley",
            "lastName": "Wilson",
            "productName": "Espresso Truffle",
            "price": 1.75,
            "quantity": 2,
            "total": 3.5
        },
        {
            "id": 87,
            "firstName": "Nancy",
            "lastName": "Fuller",
            "productName": "Peppermint Mocha Twist",
            "price": 4,
            "quantity": 8,
            "total": 32
        },
        {
            "id": 88,
            "firstName": "Beate",
            "lastName": "Devling",
            "productName": "Espresso con Panna",
            "price": 3.25,
            "quantity": 9,
            "total": 29.25
        },
        {
            "id": 89,
            "firstName": "Ian",
            "lastName": "Petersen",
            "productName": "Peppermint Mocha Twist",
            "price": 4,
            "quantity": 8,
            "total": 32
        },
        {
            "id": 90,
            "firstName": "Lars",
            "lastName": "Saavedra",
            "productName": "Caffe Latte",
            "price": 4.5,
            "quantity": 8,
            "total": 36
        },
        {
            "id": 91,
            "firstName": "Michael",
            "lastName": "Saavedra",
            "productName": "Espresso Truffle",
            "price": 1.75,
            "quantity": 3,
            "total": 5.25
        },
        {
            "id": 92,
            "firstName": "Ian",
            "lastName": "Bjorn",
            "productName": "Caffe Espresso",
            "price": 3,
            "quantity": 7,
            "total": 21
        },
        {
            "id": 93,
            "firstName": "Antoni",
            "lastName": "Burke",
            "productName": "Cappuccino",
            "price": 5,
            "quantity": 5,
            "total": 25
        },
        {
            "id": 94,
            "firstName": "Regina",
            "lastName": "Fuller",
            "productName": "Doubleshot Espresso",
            "price": 3.3,
            "quantity": 6,
            "total": 19.799999999999997
        },
        {
            "id": 95,
            "firstName": "Shelley",
            "lastName": "Saylor",
            "productName": "Caffe Americano",
            "price": 2.5,
            "quantity": 11,
            "total": 27.5
        },
        {
            "id": 96,
            "firstName": "Antoni",
            "lastName": "Ohno",
            "productName": "Caffe Americano",
            "price": 2.5,
            "quantity": 3,
            "total": 7.5
        },
        {
            "id": 97,
            "firstName": "Petra",
            "lastName": "Rossi",
            "productName": "Caffe Latte",
            "price": 4.5,
            "quantity": 6,
            "total": 27
        },
        {
            "id": 98,
            "firstName": "Mayumi",
            "lastName": "Saavedra",
            "productName": "Doubleshot Espresso",
            "price": 3.3,
            "quantity": 7,
            "total": 23.099999999999998
        },
        {
            "id": 99,
            "firstName": "Nancy",
            "lastName": "Davolio",
            "productName": "Cramel Latte",
            "price": 3.8,
            "quantity": 6,
            "total": 22.799999999999997
        },
        {
            "id": 100,
            "firstName": "Cheryl",
            "lastName": "Ohno",
            "productName": "Espresso Truffle",
            "price": 1.75,
            "quantity": 3,
            "total": 5.25
        }
    ]
}

function filterData(data, filtering) {

    const filtered = data.filter(product => {

        const dataFields = Object.keys(filtering);

        let doesMeet = true;

        dataFields.forEach(field => {

            const filters = filtering[field].filters;
            const logicalOperators = filtering[field].logicalOperators  //0 - and, 1 - or

            const metFilters = [];

            filters.forEach(filter => {

                const value = filter.value;
                const condition = filter.condition;

                let doesMeet = true;

                switch (condition) {
                    case "starts with":
                    case "STARTS_WITH":
                        doesMeet = product[field].startsWith(value)
                        break;
                    case "ends with":
                    case "ENDS_WITH":
                        doesMeet = product[field].endsWith(value)
                        break;
                    case "EMPTY":
                        doesMeet = product[field] === ""
                        break;
                    case "NOT_EMPTY":
                        doesMeet = product[field] !== ""
                        break;
                    case "CONTAINS":
                        doesMeet = product[field].includes(value)
                        break;
                    case "DOES_NOT_CONTAINS":
                        doesMeet = !product[field].includes(value)
                        break;
                    case "NULL":
                        doesMeet = product[field] === null
                        break;
                    case "NOT_NULL":
                        doesMeet = product[field] !== null
                        break;
                    case "EQUAL":
                    case "=":
                        doesMeet = product[field] === value
                        break;
                    case "NOT_EQUAL":
                    case "<>":
                    case "!=":
                        doesMeet = product[field] !== value
                        break;
                    case "LESS_THAN":
                    case "<":
                        doesMeet = product[field] < value
                        break;
                    case "GREATER_THAN":
                    case ">":
                        doesMeet = product[field] > value
                        break;
                    case "LESS_THAN_OR_EQUAL":
                    case "<=":
                        doesMeet = product[field] <= value
                        break;
                    case "GREATER_THAN_OR_EQUAL":
                    case ">=":
                        doesMeet = product[field] >= value
                        break;
                    default:
                        break;
                }

                metFilters.push(doesMeet);
            })

            if (
                (logicalOperators.length === 1 && metFilters.some(f => f === false))
                || (logicalOperators[0] === 0 && metFilters.some(f => f === false))
                || (logicalOperators[0] === 1 && metFilters.every(f => f === false))
            ) {
                doesMeet = false;
            }
        })

        return doesMeet
    })

    return filtered
}

function sortData(data, sorting) {
    data = data.sort((a, b) => {

        const dataFields = Object.keys(sorting);

        for (let i = 0; i < dataFields.length; i++) {

            const dataField = dataFields[i];

            const order = sorting[dataField].sortOrder.toLowerCase();
            if (!isNaN(a[dataField])) {

                const flag = order.includes('asc')
                    ? Number(a[dataField]) - Number(b[dataField])
                    : Number(b[dataField]) - Number(a[dataField])

                if (flag !== 0) {
                    return flag > 0 ? 1 : -1
                }

            } else {

                const flag = order.includes('asc')
                    ? a[dataField].localeCompare(b[dataField])
                    : b[dataField].localeCompare(a[dataField])

                if (flag !== 0) {
                    return flag
                }

            }

        }
    })
}

function reduceData(first, last, filtering, sorting) {

    const responseData = {
        data: data,
        length: data.length
    }

    const filtered = filterData(responseData.data, filtering)

    responseData.data = filtered;
    responseData.length = filtered.length

    sortData(responseData.data, sorting)

    if (first && last) {
        responseData.data = responseData.data.slice(first, last + 1);
    }

    return responseData;
}